<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!--NewPage-->
<HTML>
<HEAD>
<!-- Generated by javadoc (build 1.5.0_06) on Wed Aug 20 17:16:46 PDT 2008 -->
<TITLE>
TreeMultiset (Google Collections Library - snapshot-20080820 (ALPHA))
</TITLE>

<META NAME="keywords" CONTENT="com.google.common.collect.TreeMultiset class">

<LINK REL ="stylesheet" TYPE="text/css" HREF="../../../../stylesheet.css" TITLE="Style">

<SCRIPT type="text/javascript">
function windowTitle()
{
    parent.document.title="TreeMultiset (Google Collections Library - snapshot-20080820 (ALPHA))";
}
</SCRIPT>
<NOSCRIPT>
</NOSCRIPT>

</HEAD>

<BODY BGCOLOR="white" onload="windowTitle();">


<!-- ========= START OF TOP NAVBAR ======= -->
<A NAME="navbar_top"><!-- --></A>
<A HREF="#skip-navbar_top" title="Skip navigation links"></A>
<TABLE BORDER="0" WIDTH="100%" CELLPADDING="1" CELLSPACING="0" SUMMARY="">
<TR>
<TD COLSPAN=2 BGCOLOR="#EEEEFF" CLASS="NavBarCell1">
<A NAME="navbar_top_firstrow"><!-- --></A>
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="3" SUMMARY="">
  <TR ALIGN="center" VALIGN="top">
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../overview-summary.html"><FONT CLASS="NavBarFont1"><B>Overview</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-summary.html"><FONT CLASS="NavBarFont1"><B>Package</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#FFFFFF" CLASS="NavBarCell1Rev"> &nbsp;<FONT CLASS="NavBarFont1Rev"><B>Class</B></FONT>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-tree.html"><FONT CLASS="NavBarFont1"><B>Tree</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../deprecated-list.html"><FONT CLASS="NavBarFont1"><B>Deprecated</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../index-all.html"><FONT CLASS="NavBarFont1"><B>Index</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../help-doc.html"><FONT CLASS="NavBarFont1"><B>Help</B></FONT></A>&nbsp;</TD>
  </TR>
</TABLE>
</TD>
<TD ALIGN="right" VALIGN="top" ROWSPAN=3><EM>
</EM>
</TD>
</TR>

<TR>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
&nbsp;<A HREF="../../../../com/google/common/collect/TreeMultimap.html" title="class in com.google.common.collect"><B>PREV CLASS</B></A>&nbsp;
&nbsp;<A HREF="../../../../com/google/common/collect/UnmodifiableIterator.html" title="class in com.google.common.collect"><B>NEXT CLASS</B></A></FONT></TD>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
  <A HREF="../../../../index.html?com/google/common/collect/TreeMultiset.html" target="_top"><B>FRAMES</B></A>  &nbsp;
&nbsp;<A HREF="TreeMultiset.html" target="_top"><B>NO FRAMES</B></A>  &nbsp;
&nbsp;<SCRIPT type="text/javascript">
  <!--
  if(window==top) {
    document.writeln('<A HREF="../../../../allclasses-noframe.html"><B>All Classes</B></A>');
  }
  //-->
</SCRIPT>
<NOSCRIPT>
  <A HREF="../../../../allclasses-noframe.html"><B>All Classes</B></A>
</NOSCRIPT>


</FONT></TD>
</TR>
<TR>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
  SUMMARY:&nbsp;NESTED&nbsp;|&nbsp;FIELD&nbsp;|&nbsp;<A HREF="#constructor_summary">CONSTR</A>&nbsp;|&nbsp;<A HREF="#method_summary">METHOD</A></FONT></TD>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
DETAIL:&nbsp;FIELD&nbsp;|&nbsp;<A HREF="#constructor_detail">CONSTR</A>&nbsp;|&nbsp;<A HREF="#method_detail">METHOD</A></FONT></TD>
</TR>
</TABLE>
<A NAME="skip-navbar_top"></A>
<!-- ========= END OF TOP NAVBAR ========= -->

<HR>
<!-- ======== START OF CLASS DATA ======== -->
<H2>
<FONT SIZE="-1">
com.google.common.collect</FONT>
<BR>
Class TreeMultiset&lt;E&gt;</H2>
<PRE>
<A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html" title="class or interface in java.lang">java.lang.Object</A>
  <IMG SRC="../../../../resources/inherit.gif" ALT="extended by "><A HREF="http://java.sun.com/javase/6/docs/api/java/util/AbstractCollection.html" title="class or interface in java.util">java.util.AbstractCollection</A>&lt;E&gt;
      <IMG SRC="../../../../resources/inherit.gif" ALT="extended by "><A HREF="../../../../com/google/common/collect/AbstractMultiset.html" title="class in com.google.common.collect">com.google.common.collect.AbstractMultiset</A>&lt;E&gt;
          <IMG SRC="../../../../resources/inherit.gif" ALT="extended by "><B>com.google.common.collect.TreeMultiset&lt;E&gt;</B>
</PRE>
<DL>
<DT><B>All Implemented Interfaces:</B> <DD><A HREF="../../../../com/google/common/collect/Multiset.html" title="interface in com.google.common.collect">Multiset</A>&lt;E&gt;, <A HREF="http://java.sun.com/javase/6/docs/api/java/io/Serializable.html" title="class or interface in java.io">Serializable</A>, <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Iterable.html" title="class or interface in java.lang">Iterable</A>&lt;E&gt;, <A HREF="http://java.sun.com/javase/6/docs/api/java/util/Collection.html" title="class or interface in java.util">Collection</A>&lt;E&gt;</DD>
</DL>
<HR>
<DL>
<DT><PRE>public final class <B>TreeMultiset&lt;E&gt;</B><DT>extends <A HREF="../../../../com/google/common/collect/AbstractMultiset.html" title="class in com.google.common.collect">AbstractMultiset</A>&lt;E&gt;</DL>
</PRE>

<P>
Multiset implementation backed by a <code>TreeMap</code>. The multiset elements
 are ordered by their natural sort ordering or by a comparator.
<P>

<P>
<DL>
<DT><B>Author:</B></DT>
  <DD>Neal Kanodia, Jared Levy</DD>
<DT><B>See Also:</B><DD><A HREF="../../../../serialized-form.html#com.google.common.collect.TreeMultiset">Serialized Form</A></DL>
<HR>

<P>
<!-- ======== NESTED CLASS SUMMARY ======== -->

<A NAME="nested_class_summary"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="2"><FONT SIZE="+2">
<B>Nested Class Summary</B></FONT></TH>
</TR>
</TABLE>
&nbsp;<A NAME="nested_classes_inherited_from_class_com.google.common.collect.Multiset"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#EEEEFF" CLASS="TableSubHeadingColor">
<TH ALIGN="left"><B>Nested classes/interfaces inherited from interface com.google.common.collect.<A HREF="../../../../com/google/common/collect/Multiset.html" title="interface in com.google.common.collect">Multiset</A></B></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD><CODE><A HREF="../../../../com/google/common/collect/Multiset.Entry.html" title="interface in com.google.common.collect">Multiset.Entry</A>&lt;<A HREF="../../../../com/google/common/collect/Multiset.Entry.html" title="type parameter in Multiset.Entry">E</A>&gt;</CODE></TD>
</TR>
</TABLE>
&nbsp;

<!-- ======== CONSTRUCTOR SUMMARY ======== -->

<A NAME="constructor_summary"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="2"><FONT SIZE="+2">
<B>Constructor Summary</B></FONT></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD><CODE><B><A HREF="../../../../com/google/common/collect/TreeMultiset.html#TreeMultiset()">TreeMultiset</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Constructs a new, empty multiset, sorted according to the elements' natural
 order.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD><CODE><B><A HREF="../../../../com/google/common/collect/TreeMultiset.html#TreeMultiset(java.util.Comparator)">TreeMultiset</A></B>(<A HREF="http://java.sun.com/javase/6/docs/api/java/util/Comparator.html" title="class or interface in java.util">Comparator</A>&lt;? super <A HREF="../../../../com/google/common/collect/TreeMultiset.html" title="type parameter in TreeMultiset">E</A>&gt;&nbsp;comparator)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Constructs a new, empty multiset, sorted according to the specified
 comparator.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD><CODE><B><A HREF="../../../../com/google/common/collect/TreeMultiset.html#TreeMultiset(java.lang.Iterable)">TreeMultiset</A></B>(<A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Iterable.html" title="class or interface in java.lang">Iterable</A>&lt;? extends <A HREF="../../../../com/google/common/collect/TreeMultiset.html" title="type parameter in TreeMultiset">E</A>&gt;&nbsp;elements)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Constructs an empty multiset containing the given initial elements, sorted
 according to the elements' natural order.</TD>
</TR>
</TABLE>
&nbsp;
<!-- ========== METHOD SUMMARY =========== -->

<A NAME="method_summary"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="2"><FONT SIZE="+2">
<B>Method Summary</B></FONT></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;boolean</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/collect/TreeMultiset.html#add(E, int)">add</A></B>(E&nbsp;element,
    int&nbsp;occurrences)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Adds a number of occurrences of an element to this multiset. Note that if
 <code>occurrences == 1</code>, this method has the identical effect to <A HREF="../../../../com/google/common/collect/Multiset.html#add(E)"><CODE>Multiset.add(Object)</CODE></A>. This method is functionally equivalent (except in the case
 of overflow) to the call <code>addAll(Collections.nCopies(element,
 occurrences))</code>, which would presumably perform much more poorly.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>protected &nbsp;<A HREF="http://java.sun.com/javase/6/docs/api/java/util/Map.html" title="class or interface in java.util">Map</A>&lt;E,<A HREF="http://java.sun.com/javase/6/docs/api/java/util/concurrent/atomic/AtomicInteger.html" title="class or interface in java.util.concurrent.atomic">AtomicInteger</A>&gt;</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/collect/TreeMultiset.html#backingMap()">backingMap</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/collect/TreeMultiset.html#count(java.lang.Object)">count</A></B>(<A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html" title="class or interface in java.lang">Object</A>&nbsp;element)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns the number of occurrences of an element in this multiset (the
 <i>count</i> of the element).</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>protected &nbsp;<A HREF="http://java.sun.com/javase/6/docs/api/java/util/Set.html" title="class or interface in java.util">Set</A>&lt;<A HREF="../../../../com/google/common/collect/TreeMultiset.html" title="type parameter in TreeMultiset">E</A>&gt;</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/collect/TreeMultiset.html#createElementSet()">createElementSet</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Creates a new instance of this multiset's element set, which will be
 returned by <A HREF="../../../../com/google/common/collect/AbstractMultiset.html#elementSet"><CODE>AbstractMultiset.elementSet</CODE></A>.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="http://java.sun.com/javase/6/docs/api/java/util/SortedSet.html" title="class or interface in java.util">SortedSet</A>&lt;<A HREF="../../../../com/google/common/collect/TreeMultiset.html" title="type parameter in TreeMultiset">E</A>&gt;</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/collect/TreeMultiset.html#elementSet()">elementSet</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns the set of distinct elements contained in this multiset. The
 element set is backed by the same data as the multiset, so any change to
 either is immediately reflected in the other. The order of the elements in
 the element set is unspecified.

 <p>If the element set supports any removal operations, these necessarily
 cause <b>all</b> occurrences of the removed element(s) to be removed from
 the multiset. Implementations are not expected to support the add
 operations, although this is possible.

 <p>A common use for the element set is to find the number of distinct
 elements in the multiset: <code>elementSet().size()</code>.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="http://java.sun.com/javase/6/docs/api/java/util/Set.html" title="class or interface in java.util">Set</A>&lt;<A HREF="../../../../com/google/common/collect/Multiset.Entry.html" title="interface in com.google.common.collect">Multiset.Entry</A>&lt;E&gt;&gt;</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/collect/TreeMultiset.html#entrySet()">entrySet</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns a view of the contents of this multiset, grouped into <code>Multiset.Entry</code> instances, each providing an element of the multiset and
 the count of that element.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="http://java.sun.com/javase/6/docs/api/java/util/Iterator.html" title="class or interface in java.util">Iterator</A>&lt;E&gt;</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/collect/TreeMultiset.html#iterator()">iterator</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns an iterator over the elements contained in this collection.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>protected &nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/collect/TreeMultiset.html#readObjectNoData()">readObjectNoData</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Don't allow default serialization.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/collect/TreeMultiset.html#remove(java.lang.Object, int)">remove</A></B>(<A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html" title="class or interface in java.lang">Object</A>&nbsp;element,
       int&nbsp;occurrences)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Conditionally removes a number of occurrences of an element from this
 multiset, provided that at least this many occurrences are present.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/collect/TreeMultiset.html#removeAllOccurrences(java.lang.Object)">removeAllOccurrences</A></B>(<A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html" title="class or interface in java.lang">Object</A>&nbsp;element)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Removes <b>all</b> occurrences of the specified element from this multiset.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>protected &nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/collect/TreeMultiset.html#setBackingMap(java.util.Map)">setBackingMap</A></B>(<A HREF="http://java.sun.com/javase/6/docs/api/java/util/Map.html" title="class or interface in java.util">Map</A>&lt;E,<A HREF="http://java.sun.com/javase/6/docs/api/java/util/concurrent/atomic/AtomicInteger.html" title="class or interface in java.util.concurrent.atomic">AtomicInteger</A>&gt;&nbsp;backingMap)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Used during deserialization only.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/collect/TreeMultiset.html#size()">size</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns the number of elements in this collection.</TD>
</TR>
</TABLE>
&nbsp;<A NAME="methods_inherited_from_class_com.google.common.collect.AbstractMultiset"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#EEEEFF" CLASS="TableSubHeadingColor">
<TH ALIGN="left"><B>Methods inherited from class com.google.common.collect.<A HREF="../../../../com/google/common/collect/AbstractMultiset.html" title="class in com.google.common.collect">AbstractMultiset</A></B></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD><CODE><A HREF="../../../../com/google/common/collect/AbstractMultiset.html#add(E)">add</A>, <A HREF="../../../../com/google/common/collect/AbstractMultiset.html#addAll(java.util.Collection)">addAll</A>, <A HREF="../../../../com/google/common/collect/AbstractMultiset.html#clear()">clear</A>, <A HREF="../../../../com/google/common/collect/AbstractMultiset.html#contains(java.lang.Object)">contains</A>, <A HREF="../../../../com/google/common/collect/AbstractMultiset.html#containsAll(java.util.Collection)">containsAll</A>, <A HREF="../../../../com/google/common/collect/AbstractMultiset.html#equals(java.lang.Object)">equals</A>, <A HREF="../../../../com/google/common/collect/AbstractMultiset.html#hashCode()">hashCode</A>, <A HREF="../../../../com/google/common/collect/AbstractMultiset.html#isEmpty()">isEmpty</A>, <A HREF="../../../../com/google/common/collect/AbstractMultiset.html#remove(java.lang.Object)">remove</A>, <A HREF="../../../../com/google/common/collect/AbstractMultiset.html#removeAll(java.util.Collection)">removeAll</A>, <A HREF="../../../../com/google/common/collect/AbstractMultiset.html#retainAll(java.util.Collection)">retainAll</A>, <A HREF="../../../../com/google/common/collect/AbstractMultiset.html#toString()">toString</A></CODE></TD>
</TR>
</TABLE>
&nbsp;<A NAME="methods_inherited_from_class_java.util.AbstractCollection"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#EEEEFF" CLASS="TableSubHeadingColor">
<TH ALIGN="left"><B>Methods inherited from class java.util.<A HREF="http://java.sun.com/javase/6/docs/api/java/util/AbstractCollection.html" title="class or interface in java.util">AbstractCollection</A></B></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD><CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/util/AbstractCollection.html#toArray()" title="class or interface in java.util">toArray</A>, <A HREF="http://java.sun.com/javase/6/docs/api/java/util/AbstractCollection.html#toArray(T[])" title="class or interface in java.util">toArray</A></CODE></TD>
</TR>
</TABLE>
&nbsp;<A NAME="methods_inherited_from_class_java.lang.Object"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#EEEEFF" CLASS="TableSubHeadingColor">
<TH ALIGN="left"><B>Methods inherited from class java.lang.<A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html" title="class or interface in java.lang">Object</A></B></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD><CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html#clone()" title="class or interface in java.lang">clone</A>, <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html#finalize()" title="class or interface in java.lang">finalize</A>, <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html#getClass()" title="class or interface in java.lang">getClass</A>, <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html#notify()" title="class or interface in java.lang">notify</A>, <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html#notifyAll()" title="class or interface in java.lang">notifyAll</A>, <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html#wait()" title="class or interface in java.lang">wait</A>, <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html#wait(long)" title="class or interface in java.lang">wait</A>, <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html#wait(long, int)" title="class or interface in java.lang">wait</A></CODE></TD>
</TR>
</TABLE>
&nbsp;<A NAME="methods_inherited_from_class_java.util.Collection"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#EEEEFF" CLASS="TableSubHeadingColor">
<TH ALIGN="left"><B>Methods inherited from interface java.util.<A HREF="http://java.sun.com/javase/6/docs/api/java/util/Collection.html" title="class or interface in java.util">Collection</A></B></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD><CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/util/Collection.html#toArray()" title="class or interface in java.util">toArray</A>, <A HREF="http://java.sun.com/javase/6/docs/api/java/util/Collection.html#toArray(T[])" title="class or interface in java.util">toArray</A></CODE></TD>
</TR>
</TABLE>
&nbsp;
<P>

<!-- ========= CONSTRUCTOR DETAIL ======== -->

<A NAME="constructor_detail"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="1"><FONT SIZE="+2">
<B>Constructor Detail</B></FONT></TH>
</TR>
</TABLE>

<A NAME="TreeMultiset()"><!-- --></A><H3>
TreeMultiset</H3>
<PRE>
public <B>TreeMultiset</B>()</PRE>
<DL>
<DD>Constructs a new, empty multiset, sorted according to the elements' natural
 order. All elements inserted into the multiset must implement the
 <code>Comparable</code> interface. Furthermore, all such elements must be
 <i>mutually comparable</i>: <code>e1.compareTo(e2)</code> must not throw a
 <code>ClassCastException</code> for any elements <code>e1</code> and <code>e2</code> in
 the multiset. If the user attempts to add an element to the multiset that
 violates this constraint (for example, the user attempts to add a string
 element to a set whose elements are integers), the <code>add(Object)</code>
 call will throw a <code>ClassCastException</code>.
<P>
</DL>
<HR>

<A NAME="TreeMultiset(java.util.Comparator)"><!-- --></A><H3>
TreeMultiset</H3>
<PRE>
public <B>TreeMultiset</B>(<A HREF="http://java.sun.com/javase/6/docs/api/java/util/Comparator.html" title="class or interface in java.util">Comparator</A>&lt;? super <A HREF="../../../../com/google/common/collect/TreeMultiset.html" title="type parameter in TreeMultiset">E</A>&gt;&nbsp;comparator)</PRE>
<DL>
<DD>Constructs a new, empty multiset, sorted according to the specified
 comparator. All elements inserted into the multiset must be <i>mutually
 comparable</i> by the specified comparator: <code>comparator.compare(e1,
 e2)</code> must not throw a <code>ClassCastException</code> for any elements <code>e1</code> and <code>e2</code> in the multiset. If the user attempts to add an element
 to the multiset that violates this constraint, the <code>add(Object)</code> call
 will throw a <code>ClassCastException</code>.
<P>
<DL>
<DT><B>Parameters:</B><DD><CODE>comparator</CODE> - the comparator that will be used to sort this multiset. A
     null value indicates that the elements' <i>natural ordering</i> should
     be used.</DL>
</DL>
<HR>

<A NAME="TreeMultiset(java.lang.Iterable)"><!-- --></A><H3>
TreeMultiset</H3>
<PRE>
public <B>TreeMultiset</B>(<A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Iterable.html" title="class or interface in java.lang">Iterable</A>&lt;? extends <A HREF="../../../../com/google/common/collect/TreeMultiset.html" title="type parameter in TreeMultiset">E</A>&gt;&nbsp;elements)</PRE>
<DL>
<DD>Constructs an empty multiset containing the given initial elements, sorted
 according to the elements' natural order.
<P>
</DL>

<!-- ============ METHOD DETAIL ========== -->

<A NAME="method_detail"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="1"><FONT SIZE="+2">
<B>Method Detail</B></FONT></TH>
</TR>
</TABLE>

<A NAME="elementSet()"><!-- --></A><H3>
elementSet</H3>
<PRE>
public <A HREF="http://java.sun.com/javase/6/docs/api/java/util/SortedSet.html" title="class or interface in java.util">SortedSet</A>&lt;<A HREF="../../../../com/google/common/collect/TreeMultiset.html" title="type parameter in TreeMultiset">E</A>&gt; <B>elementSet</B>()</PRE>
<DL>
<DD>Returns the set of distinct elements contained in this multiset. The
 element set is backed by the same data as the multiset, so any change to
 either is immediately reflected in the other. The order of the elements in
 the element set is unspecified.

 <p>If the element set supports any removal operations, these necessarily
 cause <b>all</b> occurrences of the removed element(s) to be removed from
 the multiset. Implementations are not expected to support the add
 operations, although this is possible.

 <p>A common use for the element set is to find the number of distinct
 elements in the multiset: <code>elementSet().size()</code>.

 <p>The returned set's methods are implemented by calling
 <A HREF="../../../../com/google/common/collect/Multiset.html#entrySet()"><CODE>Multiset.entrySet()</CODE></A> methods.

 <p>In <code>TreeMultiset</code>, the return type of this method is narrowed
 from <A HREF="http://java.sun.com/javase/6/docs/api/java/util/Set.html" title="class or interface in java.util"><CODE>Set</CODE></A> to <A HREF="http://java.sun.com/javase/6/docs/api/java/util/SortedSet.html" title="class or interface in java.util"><CODE>SortedSet</CODE></A>.
<P>
<DD><DL>
<DT><B>Specified by:</B><DD><CODE><A HREF="../../../../com/google/common/collect/Multiset.html#elementSet()">elementSet</A></CODE> in interface <CODE><A HREF="../../../../com/google/common/collect/Multiset.html" title="interface in com.google.common.collect">Multiset</A>&lt;<A HREF="../../../../com/google/common/collect/TreeMultiset.html" title="type parameter in TreeMultiset">E</A>&gt;</CODE><DT><B>Overrides:</B><DD><CODE><A HREF="../../../../com/google/common/collect/AbstractMultiset.html#elementSet()">elementSet</A></CODE> in class <CODE><A HREF="../../../../com/google/common/collect/AbstractMultiset.html" title="class in com.google.common.collect">AbstractMultiset</A>&lt;<A HREF="../../../../com/google/common/collect/TreeMultiset.html" title="type parameter in TreeMultiset">E</A>&gt;</CODE></DL>
</DD>
<DD><DL>

<DT><B>Returns:</B><DD>a view of the set of distinct elements in this multiset</DL>
</DD>
</DL>
<HR>

<A NAME="count(java.lang.Object)"><!-- --></A><H3>
count</H3>
<PRE>
public int <B>count</B>(<FONT SIZE="-1"><A HREF="../../../../com/google/common/base/Nullable.html" title="annotation in com.google.common.base">@Nullable</A></FONT>
                 <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html" title="class or interface in java.lang">Object</A>&nbsp;element)</PRE>
<DL>
<DD><B>Description copied from class: <CODE><A HREF="../../../../com/google/common/collect/AbstractMultiset.html#count(java.lang.Object)">AbstractMultiset</A></CODE></B></DD>
<DD>Returns the number of occurrences of an element in this multiset (the
 <i>count</i> of the element). Note that for an <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html#equals(java.lang.Object)" title="class or interface in java.lang"><CODE>Object.equals(java.lang.Object)</CODE></A>-based
 multiset, this gives the same result as <A HREF="http://java.sun.com/javase/6/docs/api/java/util/Collections.html#frequency(java.util.Collection, java.lang.Object)" title="class or interface in java.util"><CODE>Collections.frequency(java.util.Collection<?>, java.lang.Object)</CODE></A>
 (which would presumably perform more poorly).

 <p><b>Note:</b> the utility method <A HREF="../../../../com/google/common/collect/Iterables.html#frequency(java.lang.Iterable, java.lang.Object)"><CODE>Iterables.frequency(java.lang.Iterable<?>, java.lang.Object)</CODE></A> generalizes
 this operation; it correctly delegates to this method when dealing with a
 multiset, but it can also accept any other iterable type.

 <p>This implementation iterates across <A HREF="../../../../com/google/common/collect/Multiset.html#entrySet()"><CODE>Multiset.entrySet()</CODE></A> and
 sums the count of all entries.
<P>
<DD><DL>
<DT><B>Specified by:</B><DD><CODE><A HREF="../../../../com/google/common/collect/Multiset.html#count(java.lang.Object)">count</A></CODE> in interface <CODE><A HREF="../../../../com/google/common/collect/Multiset.html" title="interface in com.google.common.collect">Multiset</A>&lt;<A HREF="../../../../com/google/common/collect/TreeMultiset.html" title="type parameter in TreeMultiset">E</A>&gt;</CODE></DL>
</DD>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>element</CODE> - the element to count occurrences of
<DT><B>Returns:</B><DD>the number of occurrences of the element in this multiset; possibly
     zero but never negative</DL>
</DD>
</DL>
<HR>

<A NAME="removeAllOccurrences(java.lang.Object)"><!-- --></A><H3>
removeAllOccurrences</H3>
<PRE>
public int <B>removeAllOccurrences</B>(<FONT SIZE="-1"><A HREF="../../../../com/google/common/base/Nullable.html" title="annotation in com.google.common.base">@Nullable</A></FONT>
                                <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html" title="class or interface in java.lang">Object</A>&nbsp;element)</PRE>
<DL>
<DD><B>Description copied from class: <CODE><A HREF="../../../../com/google/common/collect/AbstractMultiset.html#removeAllOccurrences(java.lang.Object)">AbstractMultiset</A></CODE></B></DD>
<DD>Removes <b>all</b> occurrences of the specified element from this multiset.
 This method complements <A HREF="../../../../com/google/common/collect/Multiset.html#remove(java.lang.Object)"><CODE>Multiset.remove(Object)</CODE></A>, which removes only
 one occurrence at a time.

 TODO: Nuke this.  Use setCount(e, 0).

 <p>This implementation calls <A HREF="../../../../com/google/common/collect/AbstractMultiset.html#remove(java.lang.Object, int)"><CODE>AbstractMultiset.remove(Object, int)</CODE></A> with
 <code>Integer.MAX_VALUE</code> occurrences.
<P>
<DD><DL>
<DT><B>Specified by:</B><DD><CODE><A HREF="../../../../com/google/common/collect/Multiset.html#removeAllOccurrences(java.lang.Object)">removeAllOccurrences</A></CODE> in interface <CODE><A HREF="../../../../com/google/common/collect/Multiset.html" title="interface in com.google.common.collect">Multiset</A>&lt;<A HREF="../../../../com/google/common/collect/TreeMultiset.html" title="type parameter in TreeMultiset">E</A>&gt;</CODE></DL>
</DD>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>element</CODE> - the element whose occurrences should all be removed
<DT><B>Returns:</B><DD>the number of occurrences successfully removed, possibly zero</DL>
</DD>
</DL>
<HR>

<A NAME="createElementSet()"><!-- --></A><H3>
createElementSet</H3>
<PRE>
protected <A HREF="http://java.sun.com/javase/6/docs/api/java/util/Set.html" title="class or interface in java.util">Set</A>&lt;<A HREF="../../../../com/google/common/collect/TreeMultiset.html" title="type parameter in TreeMultiset">E</A>&gt; <B>createElementSet</B>()</PRE>
<DL>
<DD><B>Description copied from class: <CODE><A HREF="../../../../com/google/common/collect/AbstractMultiset.html#createElementSet()">AbstractMultiset</A></CODE></B></DD>
<DD>Creates a new instance of this multiset's element set, which will be
 returned by <A HREF="../../../../com/google/common/collect/AbstractMultiset.html#elementSet"><CODE>AbstractMultiset.elementSet</CODE></A>.
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="backingMap()"><!-- --></A><H3>
backingMap</H3>
<PRE>
protected <A HREF="http://java.sun.com/javase/6/docs/api/java/util/Map.html" title="class or interface in java.util">Map</A>&lt;E,<A HREF="http://java.sun.com/javase/6/docs/api/java/util/concurrent/atomic/AtomicInteger.html" title="class or interface in java.util.concurrent.atomic">AtomicInteger</A>&gt; <B>backingMap</B>()</PRE>
<DL>
<DD><DL>
</DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="setBackingMap(java.util.Map)"><!-- --></A><H3>
setBackingMap</H3>
<PRE>
protected void <B>setBackingMap</B>(<A HREF="http://java.sun.com/javase/6/docs/api/java/util/Map.html" title="class or interface in java.util">Map</A>&lt;E,<A HREF="http://java.sun.com/javase/6/docs/api/java/util/concurrent/atomic/AtomicInteger.html" title="class or interface in java.util.concurrent.atomic">AtomicInteger</A>&gt;&nbsp;backingMap)</PRE>
<DL>
<DD>Used during deserialization only. The backing map must be empty.
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="entrySet()"><!-- --></A><H3>
entrySet</H3>
<PRE>
public <A HREF="http://java.sun.com/javase/6/docs/api/java/util/Set.html" title="class or interface in java.util">Set</A>&lt;<A HREF="../../../../com/google/common/collect/Multiset.Entry.html" title="interface in com.google.common.collect">Multiset.Entry</A>&lt;E&gt;&gt; <B>entrySet</B>()</PRE>
<DL>
<DD>Returns a view of the contents of this multiset, grouped into <code>Multiset.Entry</code> instances, each providing an element of the multiset and
 the count of that element. This set contains exactly one entry for each
 distinct element in the multiset (thus it always has the same size as the
 <A HREF="../../../../com/google/common/collect/Multiset.html#elementSet()"><CODE>Multiset.elementSet()</CODE></A>). The order of the elements in the element set is
 unspecified.

 <p>The entry set is backed by the same data as the multiset, so any change
 to either is immediately reflected in the other. However, multiset changes
 may or may not be reflected in any <code>Entry</code> instances already
 retrieved from the entry set (this is implementation-dependent).
 Furthermore, implementations are not required to support modifications to
 the entry set at all, and the <code>Entry</code> instances themselves don't
 even have methods for modification. See the specific implementation class
 for more details on how its entry set handles modifications.

 <p>Invoking <A HREF="../../../../com/google/common/collect/Multiset.Entry.html#getCount()"><CODE>Multiset.Entry.getCount()</CODE></A> on an entry in the returned
 set always returns the current count of that element in the multiset, as
 opposed to the count at the time the entry was retrieved.
<P>
<DD><DL>
<DT><B>Specified by:</B><DD><CODE><A HREF="../../../../com/google/common/collect/Multiset.html#entrySet()">entrySet</A></CODE> in interface <CODE><A HREF="../../../../com/google/common/collect/Multiset.html" title="interface in com.google.common.collect">Multiset</A>&lt;E&gt;</CODE><DT><B>Specified by:</B><DD><CODE><A HREF="../../../../com/google/common/collect/AbstractMultiset.html#entrySet()">entrySet</A></CODE> in class <CODE><A HREF="../../../../com/google/common/collect/AbstractMultiset.html" title="class in com.google.common.collect">AbstractMultiset</A>&lt;E&gt;</CODE></DL>
</DD>
<DD><DL>

<DT><B>Returns:</B><DD>a set of entries representing the data of this multiset</DL>
</DD>
</DL>
<HR>

<A NAME="size()"><!-- --></A><H3>
size</H3>
<PRE>
public int <B>size</B>()</PRE>
<DL>
<DD><B>Description copied from class: <CODE><A HREF="../../../../com/google/common/collect/AbstractMultiset.html#size()">AbstractMultiset</A></CODE></B></DD>
<DD>Returns the number of elements in this collection.  If the collection
 contains more than <tt>Integer.MAX_VALUE</tt> elements, returns
 <tt>Integer.MAX_VALUE</tt>.

 <p>This implementation iterates across <A HREF="../../../../com/google/common/collect/Multiset.html#entrySet()"><CODE>Multiset.entrySet()</CODE></A> and
 sums the counts of the entries.
<P>
<DD><DL>
<DT><B>Specified by:</B><DD><CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/util/Collection.html#size()" title="class or interface in java.util">size</A></CODE> in interface <CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/util/Collection.html" title="class or interface in java.util">Collection</A>&lt;E&gt;</CODE><DT><B>Overrides:</B><DD><CODE><A HREF="../../../../com/google/common/collect/AbstractMultiset.html#size()">size</A></CODE> in class <CODE><A HREF="../../../../com/google/common/collect/AbstractMultiset.html" title="class in com.google.common.collect">AbstractMultiset</A>&lt;E&gt;</CODE></DL>
</DD>
<DD><DL>

<DT><B>Returns:</B><DD>the number of elements in this collection.</DL>
</DD>
</DL>
<HR>

<A NAME="iterator()"><!-- --></A><H3>
iterator</H3>
<PRE>
public <A HREF="http://java.sun.com/javase/6/docs/api/java/util/Iterator.html" title="class or interface in java.util">Iterator</A>&lt;E&gt; <B>iterator</B>()</PRE>
<DL>
<DD><B>Description copied from class: <CODE><A HREF="../../../../com/google/common/collect/AbstractMultiset.html#iterator()">AbstractMultiset</A></CODE></B></DD>
<DD>Returns an iterator over the elements contained in this collection.

 <p>This implementation usually invokes methods of the
 <A HREF="../../../../com/google/common/collect/Multiset.html#entrySet()"><CODE>Multiset.entrySet()</CODE></A> iterator. However, the iterator's
 <code>remove</code> method sometimes calls the multiset's <code>remove</code>.
<P>
<DD><DL>
<DT><B>Specified by:</B><DD><CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Iterable.html#iterator()" title="class or interface in java.lang">iterator</A></CODE> in interface <CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Iterable.html" title="class or interface in java.lang">Iterable</A>&lt;E&gt;</CODE><DT><B>Specified by:</B><DD><CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/util/Collection.html#iterator()" title="class or interface in java.util">iterator</A></CODE> in interface <CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/util/Collection.html" title="class or interface in java.util">Collection</A>&lt;E&gt;</CODE><DT><B>Overrides:</B><DD><CODE><A HREF="../../../../com/google/common/collect/AbstractMultiset.html#iterator()">iterator</A></CODE> in class <CODE><A HREF="../../../../com/google/common/collect/AbstractMultiset.html" title="class in com.google.common.collect">AbstractMultiset</A>&lt;E&gt;</CODE></DL>
</DD>
<DD><DL>

<DT><B>Returns:</B><DD>an iterator over the elements contained in this collection.</DL>
</DD>
</DL>
<HR>

<A NAME="add(java.lang.Object,int)"><!-- --></A><A NAME="add(E, int)"><!-- --></A><H3>
add</H3>
<PRE>
public boolean <B>add</B>(<FONT SIZE="-1"><A HREF="../../../../com/google/common/base/Nullable.html" title="annotation in com.google.common.base">@Nullable</A></FONT>
                   E&nbsp;element,
                   int&nbsp;occurrences)</PRE>
<DL>
<DD>Adds a number of occurrences of an element to this multiset. Note that if
 <code>occurrences == 1</code>, this method has the identical effect to <A HREF="../../../../com/google/common/collect/Multiset.html#add(E)"><CODE>Multiset.add(Object)</CODE></A>. This method is functionally equivalent (except in the case
 of overflow) to the call <code>addAll(Collections.nCopies(element,
 occurrences))</code>, which would presumably perform much more poorly.

 <p>This implementation always throws an
 <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/UnsupportedOperationException.html" title="class or interface in java.lang"><CODE>UnsupportedOperationException</CODE></A>. To support adding elements, override
 it.
<P>
<DD><DL>
<DT><B>Specified by:</B><DD><CODE><A HREF="../../../../com/google/common/collect/Multiset.html#add(E, int)">add</A></CODE> in interface <CODE><A HREF="../../../../com/google/common/collect/Multiset.html" title="interface in com.google.common.collect">Multiset</A>&lt;E&gt;</CODE><DT><B>Overrides:</B><DD><CODE><A HREF="../../../../com/google/common/collect/AbstractMultiset.html#add(E, int)">add</A></CODE> in class <CODE><A HREF="../../../../com/google/common/collect/AbstractMultiset.html" title="class in com.google.common.collect">AbstractMultiset</A>&lt;E&gt;</CODE></DL>
</DD>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>element</CODE> - the element to add occurrences of; may be <code>null</code> only
     if explicitly allowed by the implementation<DD><CODE>occurrences</CODE> - the number of occurrences of this element to add. May
     be zero, in which case no change will be made.
<DT><B>Returns:</B><DD>the previous count of this element before the operation; possibly
     zero - TODO: make this the actual behavior!
<DT><B>Throws:</B>
<DD><CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/lang/IllegalArgumentException.html" title="class or interface in java.lang">IllegalArgumentException</A></CODE> - if the call would result in more than
     <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Integer.html#MAX_VALUE" title="class or interface in java.lang"><CODE>Integer.MAX_VALUE</CODE></A> occurrences of <code>element</code> in this
     multiset.</DL>
</DD>
</DL>
<HR>

<A NAME="remove(java.lang.Object, int)"><!-- --></A><H3>
remove</H3>
<PRE>
public int <B>remove</B>(<FONT SIZE="-1"><A HREF="../../../../com/google/common/base/Nullable.html" title="annotation in com.google.common.base">@Nullable</A></FONT>
                  <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html" title="class or interface in java.lang">Object</A>&nbsp;element,
                  int&nbsp;occurrences)</PRE>
<DL>
<DD><B>Description copied from class: <CODE><A HREF="../../../../com/google/common/collect/AbstractMultiset.html#remove(java.lang.Object, int)">AbstractMultiset</A></CODE></B></DD>
<DD>Conditionally removes a number of occurrences of an element from this
 multiset, provided that at least this many occurrences are present. If the
 count of the element is less than <code>occurrences</code>, no change is made.
 Note that if
 <code>occurrences == 1</code>, this is functionally equivalent to the call
 <code>remove(element)</code>.

 <p>This implementation always throws an
 <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/UnsupportedOperationException.html" title="class or interface in java.lang"><CODE>UnsupportedOperationException</CODE></A>. To support removing elements,
 override it.
<P>
<DD><DL>
<DT><B>Specified by:</B><DD><CODE><A HREF="../../../../com/google/common/collect/Multiset.html#remove(java.lang.Object, int)">remove</A></CODE> in interface <CODE><A HREF="../../../../com/google/common/collect/Multiset.html" title="interface in com.google.common.collect">Multiset</A>&lt;E&gt;</CODE><DT><B>Overrides:</B><DD><CODE><A HREF="../../../../com/google/common/collect/AbstractMultiset.html#remove(java.lang.Object, int)">remove</A></CODE> in class <CODE><A HREF="../../../../com/google/common/collect/AbstractMultiset.html" title="class in com.google.common.collect">AbstractMultiset</A>&lt;E&gt;</CODE></DL>
</DD>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>element</CODE> - the element to conditionally remove occurrences of<DD><CODE>occurrences</CODE> - the number of occurrences of this element to remove. May
     be zero, in which case no change will be made.
<DT><B>Returns:</B><DD><code>true</code> if the condition for modification was met. Unless
     <code>occurrences</code> is zero, this implies that the multiset was indeed
     modified.</DL>
</DD>
</DL>
<HR>

<A NAME="readObjectNoData()"><!-- --></A><H3>
readObjectNoData</H3>
<PRE>
protected void <B>readObjectNoData</B>()
                         throws <A HREF="http://java.sun.com/javase/6/docs/api/java/io/InvalidObjectException.html" title="class or interface in java.io">InvalidObjectException</A></PRE>
<DL>
<DD>Don't allow default serialization.
<P>
<DD><DL>
</DL>
</DD>
<DD><DL>

<DT><B>Throws:</B>
<DD><CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/io/InvalidObjectException.html" title="class or interface in java.io">InvalidObjectException</A></CODE></DL>
</DD>
</DL>
<!-- ========= END OF CLASS DATA ========= -->
<HR>


<!-- ======= START OF BOTTOM NAVBAR ====== -->
<A NAME="navbar_bottom"><!-- --></A>
<A HREF="#skip-navbar_bottom" title="Skip navigation links"></A>
<TABLE BORDER="0" WIDTH="100%" CELLPADDING="1" CELLSPACING="0" SUMMARY="">
<TR>
<TD COLSPAN=2 BGCOLOR="#EEEEFF" CLASS="NavBarCell1">
<A NAME="navbar_bottom_firstrow"><!-- --></A>
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="3" SUMMARY="">
  <TR ALIGN="center" VALIGN="top">
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../overview-summary.html"><FONT CLASS="NavBarFont1"><B>Overview</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-summary.html"><FONT CLASS="NavBarFont1"><B>Package</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#FFFFFF" CLASS="NavBarCell1Rev"> &nbsp;<FONT CLASS="NavBarFont1Rev"><B>Class</B></FONT>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-tree.html"><FONT CLASS="NavBarFont1"><B>Tree</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../deprecated-list.html"><FONT CLASS="NavBarFont1"><B>Deprecated</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../index-all.html"><FONT CLASS="NavBarFont1"><B>Index</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../help-doc.html"><FONT CLASS="NavBarFont1"><B>Help</B></FONT></A>&nbsp;</TD>
  </TR>
</TABLE>
</TD>
<TD ALIGN="right" VALIGN="top" ROWSPAN=3><EM>
</EM>
</TD>
</TR>

<TR>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
&nbsp;<A HREF="../../../../com/google/common/collect/TreeMultimap.html" title="class in com.google.common.collect"><B>PREV CLASS</B></A>&nbsp;
&nbsp;<A HREF="../../../../com/google/common/collect/UnmodifiableIterator.html" title="class in com.google.common.collect"><B>NEXT CLASS</B></A></FONT></TD>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
  <A HREF="../../../../index.html?com/google/common/collect/TreeMultiset.html" target="_top"><B>FRAMES</B></A>  &nbsp;
&nbsp;<A HREF="TreeMultiset.html" target="_top"><B>NO FRAMES</B></A>  &nbsp;
&nbsp;<SCRIPT type="text/javascript">
  <!--
  if(window==top) {
    document.writeln('<A HREF="../../../../allclasses-noframe.html"><B>All Classes</B></A>');
  }
  //-->
</SCRIPT>
<NOSCRIPT>
  <A HREF="../../../../allclasses-noframe.html"><B>All Classes</B></A>
</NOSCRIPT>


</FONT></TD>
</TR>
<TR>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
  SUMMARY:&nbsp;NESTED&nbsp;|&nbsp;FIELD&nbsp;|&nbsp;<A HREF="#constructor_summary">CONSTR</A>&nbsp;|&nbsp;<A HREF="#method_summary">METHOD</A></FONT></TD>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
DETAIL:&nbsp;FIELD&nbsp;|&nbsp;<A HREF="#constructor_detail">CONSTR</A>&nbsp;|&nbsp;<A HREF="#method_detail">METHOD</A></FONT></TD>
</TR>
</TABLE>
<A NAME="skip-navbar_bottom"></A>
<!-- ======== END OF BOTTOM NAVBAR ======= -->

<HR>

</BODY>
</HTML>
